#include <stdio.h>
#include <stdlib.h>

int *matrNr; // pointer auf Matrikelnummern
int matrSize; // die aktuelle Gre

/*************************************************
* @brief Rezise Array
**************************************************/
void resize(int size){
	int t;
	// reserve new memory
	int *pHelp = (int*) malloc(sizeof(int)*size);
	if (pHelp!=NULL){
		for (t=0;t<matrSize;t++){
			pHelp[t] = matrNr[t]; // copy data
		}
		free(matrNr);// free old memory
		matrNr = pHelp; // set pointer to new memory area
		matrSize = size;
	}
}
/**************************************************
* @brief writes a new matrNr at the position index
*        if the index is too high the resize function
*        is called
***************************************************/
void setMatrNr(int index, int matrikelNr)
{
	if (index>matrSize-1){
		resize(index+5);
	}
	matrNr[index] = matrikelNr;
}
/***************************************************
* @brief: returns the matrikelnumber for a given index
*         If the index is too high, a zero is returned
*
****************************************************/
int getMatrNr(int index)
{
	if (index>matrSize-1){
		return 0;
	}
	return matrNr[index];
}
int main(int argc, char**argv)
{
    matrSize = 0;

	setMatrNr(100,123456);
	setMatrNr(500,123456);
	printf("MatrNr[500] = %d\n",getMatrNr(500));
}